import 'package:xplane_connect/src/xplaneData_model.dart';
import 'package:udp/udp.dart';
import 'dart:typed_data';

class XplaneConnect {
  // Sets in constructor the UDP port to listen data
  final int udpPort;
  XplaneConnect(this.udpPort);

  List<XplaneDataModel> dataOutputs = [];
  UDP receiver;

  // Gets the data stream of xplane data outputs with indexed table model
  Stream<List<XplaneDataModel>> get dataStream {
    return Stream.fromFuture(listen());
  }

  Future listen() async {
    // Set UDP port to listen
    receiver = await UDP.bind(Endpoint.any(port: Port(udpPort))).then((value) {
      print(
          'UDP binded on ${value.local.address}:${value.local.port} , waiting for client');
      return value;
    }).catchError((error) {
      print('UDP error: $error');
    });

    // receiving\listening
    await receiver.listen((datagram) {
      var xPdata = datagram.data;

      // Verify data header
      var header = String.fromCharCodes(xPdata, 0, 5);
      if (header.contains('DATA')) {
        // Discart data header
        xPdata = xPdata.sublist(5, datagram.data.lengthInBytes);
      } else {
        // Worng data type
      }

      var totalLen =
          36; // set data length to 36 bytes, index[4-bytes] + data[32-bytes]

      // Get count of data outputs
      var totalData = ((xPdata.lengthInBytes) / totalLen);

      for (var dataIndex = 0; dataIndex < totalData; dataIndex++) {
        // Get data output by index
        var dataOutput =
            ByteData.view(xPdata.buffer, dataIndex * totalLen, totalLen);

        // Get data output xplane index
        var outputIndex = dataOutput.getInt32(0);

        var dataOutputItem = XplaneDataModel(
            outputIndex,
            ByteData.view(dataOutput.buffer, 5, totalLen)
                .buffer
                .asFloat32List()
                .toList());

        print(dataOutputItem.outputData);
      }

      // var data = datagram.data.sublist(9, datagram.data.lengthInBytes);

      // var bytes = data.buffer.asByteData();

      // // Print total bytes in the datafile
      // print('Total bytes: ${bytes.lengthInBytes}');

      // var dataList = data.buffer.asFloat32List(0, 4);
      // print(dataList);
    });
  }
}
